/*
 * Fred's device driver for mices and keyboards V1.0
 * (C) Fred Hucht 1995
 * EMail: fred@thp.Uni-Duisburg.DE
 * Distributed in terms of the GNU public license
 */

#ifndef _FRED_H
#define _FRED_H

#define Uchar unsigned char

struct fredmsg {
  int  addr; /* key:2 mouse:3 */
  int  id;
  int  count;
  int  ret;
  Uchar reg;
  Uchar data[8];
};

#define FRED_DEV "/dev/fred"

#define FRED_EXISTS _IOWR('F', FDB_EXISTS, struct fredmsg)
#define FRED_LISTEN _IOWR('F', FDB_LISTEN, struct fredmsg)
#define FRED_TALK   _IOWR('F', FDB_TALK,   struct fredmsg)

#define FRED_MOUSE  _IOR ('M', 1, int)			/* Query mouse state */
#define FRED_DEBUG  _IOW ('D', 1, int)			/* Enable/Disable debugging */

#define FRED_SETKID _IOWR('S', FDB_KEYBOARD, int)	/* Set dev hndlr ID of keyboard */
#define FRED_SETMID _IOWR('S', FDB_MOUSE, int)		/* Set dev hndlr ID of mouse */
#define FRED_INSTM   _IO('I', FDB_MOUSE)		/* Install own mouse intr. handler */
#define FRED_UNINSTM _IO('U', FDB_MOUSE)		/* Uninstall own mouse intr. handler */

#ifdef __STDC__
extern fdb_open  (int addr, Uchar data, void (*intr)());
extern fdb_exists(int addr, Uchar fdb_id);
extern fdb_talk  (int addr, Uchar fdb_id, Uchar fdb_reg, Uchar fdb_data[]);
extern fdb_listen(int addr, Uchar fdb_id, Uchar fdb_reg, Uchar fdb_data[], int fdb_count);
extern fdb_close (int addr);

#else
extern fdb_open  ();
extern fdb_exists();
extern fdb_talk();
extern fdb_listen();
extern fdb_close ();
#endif

#endif /* _FRED_H */
