#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <sys/fdb.h>
#include "fred.h"

int main(argc, argv)
int argc;
char *argv[];
{
  int fd, io, led = 0;
  struct fredmsg msg;
  
  led = strtol(argv[1], NULL, 0);
  
  led = ((~led & 0x100) >> 8) + ((~led & 0x10) >> 3) + ((~led & 0x1) << 2);
  
  fd = open(FRED_DEV, O_RDWR);
  if(fd < 0) {
    perror(FRED_DEV);
    return(1);
  }
  
  msg.addr    = FDB_KEYBOARD;
  msg.id      = 0;
  msg.reg     = 2;
  msg.data[0] = 0;
  msg.data[1] = led;
  msg.count   = 2;
  
  io = FRED_LISTEN;
  if(ioctl(fd, io, &msg)) {
    fprintf(stderr, "io = 0x%x\n", io);
    perror("ioctl");
  }
  printf("ret = 0x%x\n", msg.ret);
  
  close(fd);
  return(0);
}
