#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <memory.h>
#include <errno.h>
#include <sys/fdb.h>
#include "fred.h"

int main(argc, argv)
int argc;
char *argv[];
{
  int fd, io, m_id = 4, k_id = 3, r;
  
  if(argc == 3) {
    k_id = atoi(argv[1]);  
    m_id = atoi(argv[2]);  
  }
  
  fd = open(FRED_DEV, O_RDWR);
  if(fd < 0) {
    perror(FRED_DEV);
    return(1);
  }
  
#if 0
  {
    struct fredmsg msg = {
      FDB_KEYBOARD, 
      0,
      2,
      0x44,
      3,
      {FDB_KEYBOARD, k_id}
    };
    io = FRED_LISTEN;
    if(ioctl(fd, io, &msg)) {
      fprintf(stderr, "io = 0x%x\n", io);
      perror("ioctl");
    }
    printf("ret = 0x%x\n", msg.ret);
  }
#else
  io = FRED_SETKID;
  while(r = ioctl(fd, io, &k_id), errno == EBUSY) sleep(1);
  if(r < 0) {
    fprintf(stderr, "io = 0x%x\n", io);
    perror("ioctl");
  }
#endif
  
  io = FRED_SETMID;
  while(r = ioctl(fd, io, &m_id), errno == EBUSY) sleep(1);
  if(r < 0) {
    fprintf(stderr, "io = 0x%x m_id = %d EBUSY=%d r=%d\n", io, m_id, EBUSY, r);
    perror("ioctl");
  }
  
  io = FRED_INSTM;
  r = ioctl(fd, io, NULL);
  if(r < 0) {
    fprintf(stderr, "io = 0x%x r=%d\n", io, r);
    perror("ioctl");
  }
  
  return(0);
}
